# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from saphari_msgs/Humans.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import saphari_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class Humans(genpy.Message):
  _md5sum = "96f18ba080ea4be1f7a7c4adce0e77aa"
  _type = "saphari_msgs/Humans"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """int32[] observed_user_ids
Human[] humans

================================================================================
MSG: saphari_msgs/Human
std_msgs/Header header
int32 userID 
BodyPart[] bodyParts

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: saphari_msgs/BodyPart
uint8 LEFTFOOT=0
uint8 LEFTLEG=1
uint8 LEFTKNEE=2
uint8 LEFTTHIGH=3
uint8 RIGHTFOOT=4
uint8 RIGHTLEG=5
uint8 RIGHTKNEE=6
uint8 RIGHTTHIGH=7
uint8 RIGHTHIP=8
uint8 LEFTHIP=9
uint8 NECK=10
uint8 RIGHTARM=11
uint8 RIGHTELBOW=12
uint8 RIGHTFOREARM=13
uint8 RIGHTHAND=14
uint8 LEFTARM=15
uint8 LEFTELBOW=16
uint8 LEFTFOREARM=17
uint8 LEFTHAND=18
uint8 LEFTBOTTOMFACE=19
uint8 RIGHTBOTTOMFACE=20
uint8 LEFTTOPFACE=21
uint8 RIGHTTOPFACE=22
uint8 RIGHTCHEST=23
uint8 LEFTCHEST=24

#following ids are the backup for the demo using the ni tracker
uint8 HEAD=96
uint8 TORSO=97
uint8 RIGHTSHOULDER=98
uint8 LEFTSHOULDER=99

int32 id
int32 label
int32[] childIDs
geometry_msgs/Point32 centroid
geometry_msgs/TransformStamped tf
float32 radius

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href="http://www.ros.org/wiki/tf">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['observed_user_ids','humans']
  _slot_types = ['int32[]','saphari_msgs/Human[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       observed_user_ids,humans

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Humans, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.observed_user_ids is None:
        self.observed_user_ids = []
      if self.humans is None:
        self.humans = []
    else:
      self.observed_user_ids = []
      self.humans = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.observed_user_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.observed_user_ids))
      length = len(self.humans)
      buff.write(_struct_I.pack(length))
      for val1 in self.humans:
        _v1 = val1.header
        buff.write(_struct_I.pack(_v1.seq))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.userID))
        length = len(val1.bodyParts)
        buff.write(_struct_I.pack(length))
        for val2 in val1.bodyParts:
          _x = val2
          buff.write(_struct_2i.pack(_x.id, _x.label))
          length = len(val2.childIDs)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(struct.pack(pattern, *val2.childIDs))
          _v3 = val2.centroid
          _x = _v3
          buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          _v4 = val2.tf
          _v5 = _v4.header
          buff.write(_struct_I.pack(_v5.seq))
          _v6 = _v5.stamp
          _x = _v6
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v5.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v4.child_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v7 = _v4.transform
          _v8 = _v7.translation
          _x = _v8
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v9 = _v7.rotation
          _x = _v9
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(_struct_f.pack(val2.radius))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.humans is None:
        self.humans = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.observed_user_ids = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.humans = []
      for i in range(0, length):
        val1 = saphari_msgs.msg.Human()
        _v10 = val1.header
        start = end
        end += 4
        (_v10.seq,) = _struct_I.unpack(str[start:end])
        _v11 = _v10.stamp
        _x = _v11
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v10.frame_id = str[start:end].decode('utf-8')
        else:
          _v10.frame_id = str[start:end]
        start = end
        end += 4
        (val1.userID,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.bodyParts = []
        for i in range(0, length):
          val2 = saphari_msgs.msg.BodyPart()
          _x = val2
          start = end
          end += 8
          (_x.id, _x.label,) = _struct_2i.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          val2.childIDs = struct.unpack(pattern, str[start:end])
          _v12 = val2.centroid
          _x = _v12
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
          _v13 = val2.tf
          _v14 = _v13.header
          start = end
          end += 4
          (_v14.seq,) = _struct_I.unpack(str[start:end])
          _v15 = _v14.stamp
          _x = _v15
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v14.frame_id = str[start:end].decode('utf-8')
          else:
            _v14.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v13.child_frame_id = str[start:end].decode('utf-8')
          else:
            _v13.child_frame_id = str[start:end]
          _v16 = _v13.transform
          _v17 = _v16.translation
          _x = _v17
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v18 = _v16.rotation
          _x = _v18
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (val2.radius,) = _struct_f.unpack(str[start:end])
          val1.bodyParts.append(val2)
        self.humans.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.observed_user_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.observed_user_ids.tostring())
      length = len(self.humans)
      buff.write(_struct_I.pack(length))
      for val1 in self.humans:
        _v19 = val1.header
        buff.write(_struct_I.pack(_v19.seq))
        _v20 = _v19.stamp
        _x = _v20
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v19.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.userID))
        length = len(val1.bodyParts)
        buff.write(_struct_I.pack(length))
        for val2 in val1.bodyParts:
          _x = val2
          buff.write(_struct_2i.pack(_x.id, _x.label))
          length = len(val2.childIDs)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(val2.childIDs.tostring())
          _v21 = val2.centroid
          _x = _v21
          buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          _v22 = val2.tf
          _v23 = _v22.header
          buff.write(_struct_I.pack(_v23.seq))
          _v24 = _v23.stamp
          _x = _v24
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v23.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v22.child_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v25 = _v22.transform
          _v26 = _v25.translation
          _x = _v26
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v27 = _v25.rotation
          _x = _v27
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(_struct_f.pack(val2.radius))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.humans is None:
        self.humans = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.observed_user_ids = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.humans = []
      for i in range(0, length):
        val1 = saphari_msgs.msg.Human()
        _v28 = val1.header
        start = end
        end += 4
        (_v28.seq,) = _struct_I.unpack(str[start:end])
        _v29 = _v28.stamp
        _x = _v29
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v28.frame_id = str[start:end].decode('utf-8')
        else:
          _v28.frame_id = str[start:end]
        start = end
        end += 4
        (val1.userID,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.bodyParts = []
        for i in range(0, length):
          val2 = saphari_msgs.msg.BodyPart()
          _x = val2
          start = end
          end += 8
          (_x.id, _x.label,) = _struct_2i.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          val2.childIDs = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
          _v30 = val2.centroid
          _x = _v30
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
          _v31 = val2.tf
          _v32 = _v31.header
          start = end
          end += 4
          (_v32.seq,) = _struct_I.unpack(str[start:end])
          _v33 = _v32.stamp
          _x = _v33
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v32.frame_id = str[start:end].decode('utf-8')
          else:
            _v32.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v31.child_frame_id = str[start:end].decode('utf-8')
          else:
            _v31.child_frame_id = str[start:end]
          _v34 = _v31.transform
          _v35 = _v34.translation
          _x = _v35
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v36 = _v34.rotation
          _x = _v36
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (val2.radius,) = _struct_f.unpack(str[start:end])
          val1.bodyParts.append(val2)
        self.humans.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_f = struct.Struct("<f")
_struct_2I = struct.Struct("<2I")
_struct_2i = struct.Struct("<2i")
_struct_i = struct.Struct("<i")
_struct_4d = struct.Struct("<4d")
_struct_3f = struct.Struct("<3f")
_struct_3d = struct.Struct("<3d")
